%global dlrn_nvr neutron-15.2.1.dev12-1.20210409073445.40d217c
%global dlrn 1
%define upstream_version 15.2.1.dev12
%{lua: posix.setenv("RHEL_ALLOW_PYTHON2_FOR_BUILD",1)}
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif

%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global service neutron

%define cleanup_orphan_rootwrap_daemons() \
for pid in $(ps -f --ppid 1 | awk '/.*neutron-rootwrap-daemon/ { print $2 }'); do \
   kill $(ps --ppid $pid -o pid=) \
done \
%nil

%global common_desc \
Neutron is a virtual network service for Openstack. Just like \
OpenStack Nova provides an API to dynamically request and configure \
virtual servers, Neutron provides an API to dynamically request and \
configure virtual networks. These networks connect "interfaces" from \
other OpenStack services (e.g., virtual NICs from Nova VMs). The \
Neutron API supports extensions to provide advanced network \
capabilities (e.g., QoS, ACLs, network monitoring, etc.)

Name:           openstack-%{service}
Version: 15.2.1
Release: 1.20210409073445.40d217c%{?dist}
Epoch:          1
Summary:        OpenStack Networking Service

License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0: neutron-15.2.1.dev12-1.20210409073445.40d217c.tar.gz
Source1:        %{service}.logrotate
Source2:        %{service}-sudoers
Source10:       neutron-server.service
Source11:       neutron-linuxbridge-agent.service
Source12:       neutron-openvswitch-agent.service
Source15:       neutron-dhcp-agent.service
Source16:       neutron-l3-agent.service
Source17:       neutron-metadata-agent.service
Source18:       neutron-ovs-cleanup.service
Source19:       neutron-macvtap-agent.service
Source20:       neutron-metering-agent.service
Source21:       neutron-sriov-nic-agent.service
Source22:       neutron-netns-cleanup.service
Source29:       neutron-rpc-server.service

Source30:       %{service}-dist.conf
Source31:       conf.README
Source32:       neutron-linuxbridge-cleanup.service
Source33:       neutron-enable-bridge-firewall.sh
Source34:       neutron-l2-agent-sysctl.conf
# We use the legacy service to load modules because it allows to gracefully
# ignore a missing kernel module (f.e. br_netfilter on earlier kernels). It's
# essentially because .modules files are shell scripts.
Source35:       neutron-l2-agent.modules
Source36:       neutron-destroy-patch-ports.service

#
#
# patches_ignore=DROP-IN-RPM
# patches_base=40d217c6994cf7198816daad088d50f01c3a4e03
Patch0001: 0001-Prevent-providing-privsep-helper-paths-outside-etc.patch
Patch0002: 0002-Create-executable-for-removing-patch-ports.patch
Patch0003: 0003-Destroy-patch-ports-only-if-canary-flow-is-not-prese.patch
Patch0004: 0004-use-plugin-utils-from-neutron-lib.patch
Patch0005: 0005-Skip-test_linuxbridge_arp_protect-functional-tests.patch
Patch0006: 0006-Log-dissasociation-event-when-a-FIP-is-deleted.patch
Patch0007: 0007-Remove-vf_management-and-vf_extended_management-chec.patch
Patch0008: 0008-neutron-server-api-worker-process-should-be-named-to.patch
Patch0009: 0009-Do-not-skip-ports-with-ofport-unset-or-invalid.patch
Patch0010: 0010-Revert-Security-fix-allowed-address-pair-0.0.0.0-0-i.patch
Patch0011: 0011-Filter-out-port-with-invalid-ofport-in-OVS-firewall.patch
Patch0012: 0012-OVS-Fix-live-migration-connection-disruption.patch
Patch0013: 0013-Enable-bulk-updates-for-the-dnsmasq.patch
Patch0014: 0014-Fix-calling-of-add_tunnel_port-method-from-sanity-ch.patch
Patch0015: 0015-Remove-undefined-variable-host-from-ovs-agent.patch
Patch0016: 0016-Process-DHCP-events-in-order-if-related.patch
Patch0017: 0017-GRE-Add-possibility-to-create-GRE-tunnels-over-IPv6.patch
Patch0018: 0018-Fix-update-of-trunk-subports-during-live-migration.patch
Patch0019: 0019-Don-t-try-to-create-default-SG-when-security-groups-.patch
Patch0020: 0020-OVS-FW-Clean-conntrack-entries-with-mark-CT_MARK_INV.patch
Patch0021: 0021-Move-rejection-of-min-bw-rule-on-non-physnet-port-to.patch
Patch0022: 0022-Fullstack-Wait-until-min-QoS-and-Queue-registers-are.patch
Patch0023: 0023-scope-conversion-only-just-before-pyroute2-method-ca.patch
Patch0024: 0024-Add-minimum-bw-qos-rule-validation-for-network.patch
Patch0025: 0025-Improve-get_devices_with_ip-performance.patch
Patch0026: 0026-Fix-wrong-packet_type-set-for-IPv6-GRE-tunnels-in-OV.patch
Patch0027: 0027-L3-HA-Retry-when-setting-HA-router-GW-status.patch
Patch0028: 0028-OVS-FW-Allow-egress-ICMPv6-only-for-know-addresses.patch
Patch0029: 0029-Schedule-networks-to-new-segments-if-needed.patch
Patch0030: 0030-Check-project_id-tenant_id-in-API-call.patch
Patch0031: 0031-Don-t-configure-dnsmasq-entries-for-network-ports.patch
Patch0032: 0032-SR-IOV-Do-not-fail-if-ip-link-vf-min_tx_rate-is-not-.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-babel
BuildRequires:  python%{pyver}-keystoneauth1 >= 3.4.0
BuildRequires:  python%{pyver}-keystonemiddleware
BuildRequires:  python%{pyver}-neutron-lib
BuildRequires:  python%{pyver}-novaclient
BuildRequires:  python%{pyver}-os-xenapi
BuildRequires:  python%{pyver}-oslo-cache
BuildRequires:  python%{pyver}-oslo-concurrency
BuildRequires:  python%{pyver}-oslo-config
BuildRequires:  python%{pyver}-oslo-db
BuildRequires:  python%{pyver}-oslo-log
BuildRequires:  python%{pyver}-oslo-messaging
BuildRequires:  python%{pyver}-oslo-policy
BuildRequires:  python%{pyver}-oslo-privsep
BuildRequires:  python%{pyver}-oslo-rootwrap
BuildRequires:  python%{pyver}-oslo-service
BuildRequires:  python%{pyver}-oslo-upgradecheck
BuildRequires:  python%{pyver}-oslo-versionedobjects
BuildRequires:  python%{pyver}-osprofiler >= 1.3.0
BuildRequires:  python%{pyver}-ovsdbapp
BuildRequires:  python%{pyver}-pbr >= 4.0.0
BuildRequires:  python%{pyver}-psutil >= 3.2.2
BuildRequires:  python%{pyver}-pyroute2 >= 0.4.21
BuildRequires:  python%{pyver}-pecan >= 1.3.2
BuildRequires:  python%{pyver}-tenacity >= 4.4.0
BuildRequires:  python%{pyver}-os-vif
BuildRequires:  systemd
# Handle python2 exception
%if %{pyver} == 2
BuildRequires:  python%{pyver}-weakrefmethod >= 1.0.2
%endif


Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}

# dnsmasq is not a hard requirement, but is currently the only option
# when neutron-dhcp-agent is deployed.
Requires:       dnsmasq >= 2.76
Requires:       dnsmasq-utils >= 2.76

# radvd is not a hard requirement, but is currently the only option
# for IPv6 deployments.
Requires:       radvd

# dibbler is not a hard requirement, but is currently the default option
# for IPv6 prefix delegation.
Requires:       dibbler-client

# conntrack is not a hard requirement, but is currently used by L3 agent
# to immediately drop connections after a floating IP is disassociated
Requires:       conntrack-tools

# keepalived is not a hard requirement, but is currently used by DVR L3
# agent
Requires:       keepalived

# haproxy implements metadata proxy process
Requires:       haproxy >= 1.5.0

# Those are not hard requirements, ipset is used by ipset-cleanup in the subpackage,
# iptables is used by the l3-agent which currently is not in a separate package,
# iputils provides tools like arping which are used by l3-agent and iproute-tc
# (or iproute in case of CentOS 7 and RHEL 7), provides tc binary which is
# used by e.g. l3-agent and openvswitch-agent when QoS extension is enabled
# in agent's config.
Requires:       ipset
Requires:       iptables
Requires:       iputils
# In Centos 7 "tc" library is provided by iproute package
%if 0%{?fedora} || 0%{?rhel} > 7
Requires:       iproute-tc
%else
Requires:       iproute
%endif

%if 0%{?rhel} && 0%{?rhel} < 8
%{?systemd_requires}
%else
%{?systemd_ordering} # does not exist on EL7
%endif

Obsoletes:      openstack-%{service}-dev-server

%description
%{common_desc}


%package -n python%{pyver}-%{service}
Summary:        Neutron Python libraries
%{?python_provide:%python_provide python%{pyver}-%{service}}
Requires:       python%{pyver}-alembic >= 0.9.6
Requires:       python%{pyver}-debtcollector >= 1.2.0
Requires:       python%{pyver}-designateclient >= 2.7.0
Requires:       python%{pyver}-eventlet >= 0.18.2
Requires:       python%{pyver}-greenlet >= 0.4.10
Requires:       python%{pyver}-jinja2 >= 2.10
Requires:       python%{pyver}-keystoneauth1 >= 3.4.0
Requires:       python%{pyver}-keystonemiddleware >= 4.17.0
Requires:       python%{pyver}-netaddr >= 0.7.18
Requires:       python%{pyver}-neutronclient >= 6.7.0
Requires:       python%{pyver}-neutron-lib >= 1.29.1
Requires:       python%{pyver}-novaclient >= 9.1.0
Requires:       python%{pyver}-os-vif >= 1.15.1
Requires:       python%{pyver}-os-xenapi >= 0.3.1
Requires:       python%{pyver}-oslo-cache >= 1.26.0
Requires:       python%{pyver}-oslo-concurrency >= 3.26.0
Requires:       python%{pyver}-oslo-config >= 2:5.2.0
Requires:       python%{pyver}-oslo-context >= 2.19.2
Requires:       python%{pyver}-oslo-db >= 4.37.0
Requires:       python%{pyver}-oslo-i18n >= 3.15.3
Requires:       python%{pyver}-oslo-log >= 3.36.0
Requires:       python%{pyver}-oslo-messaging >= 5.29.0
Requires:       python%{pyver}-oslo-middleware >= 3.31.0
Requires:       python%{pyver}-oslo-policy >= 1.30.0
Requires:       python%{pyver}-oslo-privsep >= 1.32.0
Requires:       python%{pyver}-oslo-reports >= 1.18.0
Requires:       python%{pyver}-oslo-rootwrap >= 5.8.0
Requires:       python%{pyver}-oslo-serialization >= 2.18.0
Requires:       python%{pyver}-oslo-service >= 1.24.0
Requires:       python%{pyver}-oslo-upgradecheck >= 0.1.0
Requires:       python%{pyver}-oslo-utils >= 3.33.0
Requires:       python%{pyver}-oslo-versionedobjects >= 1.35.1
Requires:       python%{pyver}-osprofiler >= 2.3.0
Requires:       python%{pyver}-ovsdbapp
Requires:       python%{pyver}-pecan >= 1.3.2
Requires:       python%{pyver}-pbr >= 4.0.0
Requires:       python%{pyver}-psutil >= 3.2.2
Requires:       python%{pyver}-pyroute2 >= 0.5.3
Requires:       python%{pyver}-requests >= 2.14.2
Requires:       python%{pyver}-tenacity >= 4.4.0
Requires:       python%{pyver}-routes >= 2.3.1
Requires:       python%{pyver}-os-ken >= 0.3.1
Requires:       python%{pyver}-six >= 1.10.0
Requires:       python%{pyver}-sqlalchemy >= 1.2.0
Requires:       python%{pyver}-stevedore >= 1.20.0
Requires:       python%{pyver}-webob >= 1.8.2
Requires:       python%{pyver}-openstacksdk >= 0.31.2

# Handle python2 exception
%if %{pyver} == 2
Requires:       python-httplib2 >= 0.9.1
Requires:       python-netifaces >= 0.10.4
Requires:       python-paste
Requires:       python-paste-deploy >= 1.5.0
Requires:       python%{pyver}-weakrefmethod >= 1.0.2
Requires:       python-decorator >= 3.4.0
%else
Requires:       python%{pyver}-httplib2 >= 0.9.1
Requires:       python%{pyver}-netifaces >= 0.10.4
Requires:       python%{pyver}-paste
Requires:       python%{pyver}-paste-deploy >= 1.5.0
Requires:       python%{pyver}-decorator >= 3.4.0
%endif



%description -n python%{pyver}-%{service}
%{common_desc}

This package contains the Neutron Python library.


%package -n python%{pyver}-%{service}-tests
Summary:        Neutron tests
%{?python_provide:%python_provide python%{pyver}-%{service}-tests}
Requires:       python%{pyver}-%{service} = %{epoch}:%{version}-%{release}
Requires:       python%{pyver}-ddt >= 1.0.1
Requires:       python%{pyver}-fixtures >= 3.0.0
Requires:       python%{pyver}-mock >= 2.0
Requires:       python%{pyver}-subunit >= 0.0.18
Requires:       python%{pyver}-testrepository >= 0.0.18
Requires:       python%{pyver}-testtools >= 1.4.0
Requires:       python%{pyver}-testresources >= 0.2.4
Requires:       python%{pyver}-testscenarios >= 0.4
Requires:       python%{pyver}-oslotest >= 1.10.0
Requires:       python%{pyver}-os-testr >= 0.7.0
Requires:       python%{pyver}-PyMySQL >= 0.6.2
Requires:       python%{pyver}-tempest >= 12.1.0

# Handle python2 exception
%if %{pyver} == 2
Requires:       python-webtest >= 2.0
%else
Requires:       python%{pyver}-webtest >= 2.0
%endif


# pstree is used during functional testing to ensure our internal
# libraries managing processes work correctly.
Requires:       psmisc
# nfs-utils is needed because it creates user with uid 65534 which
# is required by neutron functional tests.
Requires:       nfs-utils


%description -n python%{pyver}-%{service}-tests
%{common_desc}

This package contains Neutron test files.


%package common
Summary:        Neutron common files
Requires(pre): shadow-utils
Requires:       python%{pyver}-%{service} = %{epoch}:%{version}-%{release}
Requires:       sudo


%description common
%{common_desc}

This package contains Neutron common files.


%package linuxbridge
Summary:        Neutron Linuxbridge agent
Requires:       ebtables
Requires:       ipset
Requires:       iproute
Requires:       iptables
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description linuxbridge
%{common_desc}

This package contains the Neutron agent that implements virtual
networks using VLAN or VXLAN using Linuxbridge technology.


%package macvtap-agent
Summary:        Neutron macvtap agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description macvtap-agent
%{common_desc}

This package contains the Neutron agent that implements
macvtap attachments for libvirt qemu/kvm instances.


%package ml2
Summary:        Neutron ML2 plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# needed for brocade and cisco drivers
#(TODO) ncclient is not in reuirement projects so it should be requirement in neutron
# plugin packages, not in main neutron. Remove this lines completely if everythin keeps
# working.
#Requires:       python%{pyver}-ncclient


%description ml2
%{common_desc}

This package contains a Neutron plugin that allows the use of drivers
to support separately extensible sets of network types and the mechanisms
for accessing those types.


%package openvswitch
Summary:        Neutron openvswitch plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# We require openvswitch when using vsctl to access ovsdb;
# but if we use native access, then we just need python bindings.
# since we don't know what users actually use, we depend on both.
Requires:       ipset
Requires:       iptables
Requires:       openvswitch
# Handle python2 exception
%if %{pyver} == 2
Requires:       python-openvswitch >= 2.8.0
%else
Requires:       python%{pyver}-openvswitch >= 2.8.0
%endif
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod


%description openvswitch
%{common_desc}

This package contains the Neutron plugin that implements virtual
networks using Open vSwitch.


%package metering-agent
Summary:        Neutron bandwidth metering agent
Requires:       iptables
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description metering-agent
%{common_desc}

This package contains the Neutron agent responsible for generating bandwidth
utilization notifications.


%package rpc-server
Summary:        Neutron (RPC only) Server
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description rpc-server
%{common_desc}

This package contains an alternative Neutron server that handles AMQP RPC
workload only.


%package sriov-nic-agent
Summary:        Neutron SR-IOV NIC agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description sriov-nic-agent
%{common_desc}

This package contains the Neutron agent to support advanced features of
SR-IOV network cards.


%prep
%autosetup -n %{service}-%{upstream_version} -S git
sed -i 's/\/usr\/bin\/python/\/usr\/bin\/python%{pyver}/' %{SOURCE36}

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Let's handle dependencies ourseleves
%py_req_cleanup

# Kill egg-info in order to generate new SOURCES.txt
rm -rf neutron.egg-info


%build
export SKIP_PIP_INSTALL=1
%{pyver_build}
# Generate i18n files
# (amoralej) we can remove '-D neutron' once https://review.openstack.org/#/c/485070/ is merged
%{pyver_bin} setup.py compile_catalog -d build/lib/%{service}/locale -D neutron

# Generate configuration files
PYTHONPATH=.
for file in `ls etc/oslo-config-generator/*`; do
    oslo-config-generator-%{pyver} --config-file=$file
done

find etc -name *.sample | while read filename
do
    filedir=$(dirname $filename)
    file=$(basename $filename .sample)
    mv ${filename} ${filedir}/${file}
done

# Loop through values in neutron-dist.conf and make sure that the values
# are substituted into the neutron.conf as comments. Some of these values
# will have been uncommented as a way of upstream setting defaults outside
# of the code. For notification_driver, there are commented examples
# above uncommented settings, so this specifically skips those comments
# and instead comments out the actual settings and substitutes the
# correct default values.
while read name eq value; do
  test "$name" && test "$value" || continue
  if [ "$name" = "notification_driver" ]; then
    sed -ri "0,/^$name *=/{s!^$name *=.*!# $name = $value!}" etc/%{service}.conf
  else
    sed -ri "0,/^(#)? *$name *=/{s!^(#)? *$name *=.*!# $name = $value!}" etc/%{service}.conf
  fi
done < %{SOURCE30}

%install
%{pyver_install}

# Remove unused files
rm -rf %{buildroot}%{pyver_sitelib}/bin
rm -rf %{buildroot}%{pyver_sitelib}/doc
rm -rf %{buildroot}%{pyver_sitelib}/tools

# Move rootwrap files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}/rootwrap
mv %{buildroot}/usr/etc/%{service}/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{service}/rootwrap

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}/usr/etc/%{service}/* %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini %{buildroot}%{_datadir}/%{service}/api-paste.ini

# The generated config files are not moved automatically by setup.py
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2

mv etc/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf
for agent in dhcp l3 metadata metering
do
  mv etc/${agent}_agent.ini %{buildroot}%{_sysconfdir}/%{service}/${agent}_agent.ini
done
for file in linuxbridge_agent ml2_conf openvswitch_agent sriov_agent
do
  mv etc/%{service}/plugins/ml2/${file}.ini %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2/${file}.ini
done

# Install logrotate
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install sudoers
install -p -D -m 440 %{SOURCE2} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install systemd units
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/neutron-server.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/neutron-linuxbridge-agent.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/neutron-openvswitch-agent.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/neutron-dhcp-agent.service
install -p -D -m 644 %{SOURCE16} %{buildroot}%{_unitdir}/neutron-l3-agent.service
install -p -D -m 644 %{SOURCE17} %{buildroot}%{_unitdir}/neutron-metadata-agent.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/neutron-ovs-cleanup.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/neutron-macvtap-agent.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/neutron-metering-agent.service
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_unitdir}/neutron-sriov-nic-agent.service
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_unitdir}/neutron-netns-cleanup.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/neutron-rpc-server.service
install -p -D -m 644 %{SOURCE32} %{buildroot}%{_unitdir}/neutron-linuxbridge-cleanup.service
install -p -D -m 644 %{SOURCE36} %{buildroot}%{_unitdir}/neutron-destroy-patch-ports.service

# Install helper scripts
install -p -D -m 755 %{SOURCE33} %{buildroot}%{_bindir}/neutron-enable-bridge-firewall.sh

# Install sysctl and modprobe config files to enable bridge firewalling
# NOTE(ihrachys) we effectively duplicate same settings for each affected l2
# agent. This can be revisited later.
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-openvswitch-agent.conf
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-linuxbridge-agent.conf
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules

# Install README file that describes how to configure services with custom configuration files
install -p -D -m 755 %{SOURCE31} %{buildroot}%{_sysconfdir}/%{service}/conf.d/README

# Setup directories
install -d -m 755 %{buildroot}%{_datadir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/kill_scripts

# Install dist conf
install -p -D -m 640 %{SOURCE30} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf

# Create and populate configuration directory for L3 agent that is not accessible for user modification
mkdir -p %{buildroot}%{_datadir}/%{service}/l3_agent
ln -s %{_sysconfdir}/%{service}/l3_agent.ini %{buildroot}%{_datadir}/%{service}/l3_agent/l3_agent.conf

# Create dist configuration directory for neutron-server (may be filled by advanced services)
mkdir -p %{buildroot}%{_datadir}/%{service}/server

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/common
for service in server rpc-server ovs-cleanup netns-cleanup linuxbridge-cleanup macvtap-agent; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service
done
for service in linuxbridge openvswitch dhcp l3 metadata metering sriov-nic; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service-agent
done

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{pyver_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{pyver_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{pyver_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang %{service} --all-name

%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
getent passwd %{service} >/dev/null || \
    useradd -r -g %{service} -d %{_sharedstatedir}/%{service} -s /sbin/nologin \
    -c "OpenStack Neutron Daemons" %{service}
exit 0


%post
%systemd_post neutron-dhcp-agent.service
%systemd_post neutron-l3-agent.service
%systemd_post neutron-metadata-agent.service
%systemd_post neutron-server.service
%systemd_post neutron-netns-cleanup.service
%systemd_post neutron-ovs-cleanup.service
%systemd_post neutron-linuxbridge-cleanup.service


%preun
%systemd_preun neutron-dhcp-agent.service
%systemd_preun neutron-l3-agent.service
%systemd_preun neutron-metadata-agent.service
%systemd_preun neutron-server.service
%systemd_preun neutron-netns-cleanup.service
%systemd_preun neutron-ovs-cleanup.service
%systemd_preun neutron-linuxbridge-cleanup.service


%postun
%systemd_postun_with_restart neutron-dhcp-agent.service
%systemd_postun_with_restart neutron-l3-agent.service
%systemd_postun_with_restart neutron-metadata-agent.service
%systemd_postun_with_restart neutron-server.service
%cleanup_orphan_rootwrap_daemons


%post macvtap-agent
%systemd_post neutron-macvtap-agent.service


%preun macvtap-agent
%systemd_preun neutron-macvtap-agent.service


%postun macvtap-agent
%systemd_postun_with_restart neutron-macvtap-agent.service
%cleanup_orphan_rootwrap_daemons


%post linuxbridge
%systemd_post neutron-linuxbridge-agent.service


%preun linuxbridge
%systemd_preun neutron-linuxbridge-agent.service


%postun linuxbridge
%systemd_postun_with_restart neutron-linuxbridge-agent.service
%cleanup_orphan_rootwrap_daemons

%post openvswitch
%systemd_post neutron-openvswitch-agent.service
%systemd_post neutron-destroy-patch-ports.service

if [ $1 -ge 2 ]; then
    # We're upgrading

    # Detect if the neutron-openvswitch-agent is running
    ovs_agent_running=0
    systemctl status neutron-openvswitch-agent > /dev/null 2>&1 && ovs_agent_running=1 || :

    # If agent is running, stop it
    [ $ovs_agent_running -eq 1 ] && systemctl stop neutron-openvswitch-agent > /dev/null 2>&1 || :

    # Search all orphaned neutron-rootwrap-daemon processes and since all are triggered by sudo,
    # get the actual rootwrap-daemon process.
    %cleanup_orphan_rootwrap_daemons

    # If agent was running, start it back with new code
    [ $ovs_agent_running -eq 1 ] && systemctl start neutron-openvswitch-agent > /dev/null 2>&1 || :
fi


%preun openvswitch
%systemd_preun neutron-openvswitch-agent.service
%systemd_preun neutron-destroy-patch-ports.service


%post metering-agent
%systemd_post neutron-metering-agent.service


%preun metering-agent
%systemd_preun neutron-metering-agent.service


%postun metering-agent
%systemd_postun_with_restart neutron-metering-agent.service
%cleanup_orphan_rootwrap_daemons


%post sriov-nic-agent
%systemd_post neutron-sriov-nic-agent.service


%preun sriov-nic-agent
%systemd_preun neutron-sriov-nic-agent.service


%postun sriov-nic-agent
%systemd_postun_with_restart neutron-sriov-nic-agent.service
%cleanup_orphan_rootwrap_daemons


%files
%license LICENSE
%{_bindir}/neutron-api
%{_bindir}/neutron-db-manage
%{_bindir}/neutron-debug
%{_bindir}/neutron-dhcp-agent
%{_bindir}/neutron-ipset-cleanup
%{_bindir}/neutron-keepalived-state-change
%{_bindir}/neutron-l3-agent
%{_bindir}/neutron-linuxbridge-cleanup
%{_bindir}/neutron-metadata-agent
%{_bindir}/neutron-netns-cleanup
%{_bindir}/neutron-ovs-cleanup
%{_bindir}/neutron-pd-notify
%{_bindir}/neutron-sanity-check
%{_bindir}/neutron-status
%{_bindir}/neutron-server
%{_bindir}/neutron-usage-audit
%{_unitdir}/neutron-dhcp-agent.service
%{_unitdir}/neutron-l3-agent.service
%{_unitdir}/neutron-metadata-agent.service
%{_unitdir}/neutron-server.service
%{_unitdir}/neutron-netns-cleanup.service
%{_unitdir}/neutron-ovs-cleanup.service
%{_unitdir}/neutron-linuxbridge-cleanup.service
%attr(-, root, %{service}) %{_datadir}/%{service}/api-paste.ini
%dir %{_datadir}/%{service}/l3_agent
%dir %{_datadir}/%{service}/server
%{_datadir}/%{service}/l3_agent/*.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/dhcp_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/l3_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metadata_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-dhcp-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-l3-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metadata-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-server
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-netns-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-ovs-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-cleanup
%dir %{_sysconfdir}/%{service}/kill_scripts


%files -n python%{pyver}-%{service}-tests
%license LICENSE
%{pyver_sitelib}/%{service}/tests

%files -n python%{pyver}-%{service}
%license LICENSE
%{pyver_sitelib}/%{service}
%{pyver_sitelib}/%{service}-*.egg-info
%exclude %{pyver_sitelib}/%{service}/tests


%files common -f %{service}.lang
%license LICENSE
%doc README.rst
# though this script is not exactly needed on all nodes but for ovs and
# linuxbridge agents only, it's probably good enough to put it here
%{_bindir}/neutron-enable-bridge-firewall.sh
%{_bindir}/neutron-rootwrap
%{_bindir}/neutron-rootwrap-daemon
%{_bindir}/neutron-rootwrap-xen-dom0
%dir %{_sysconfdir}/%{service}
%{_sysconfdir}/%{service}/conf.d/README
%dir %{_sysconfdir}/%{service}/conf.d
%dir %{_sysconfdir}/%{service}/conf.d/common
%dir %{_sysconfdir}/%{service}/plugins
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%{_sysconfdir}/sudoers.d/%{service}
%dir %attr(0755, %{service}, %{service}) %{_sharedstatedir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/log/%{service}
%dir %{_datarootdir}/%{service}
%dir %{_datarootdir}/%{service}/rootwrap
%{_datarootdir}/%{service}/rootwrap/debug.filters
%{_datarootdir}/%{service}/rootwrap/dhcp.filters
%{_datarootdir}/%{service}/rootwrap/dibbler.filters
%{_datarootdir}/%{service}/rootwrap/ebtables.filters
%{_datarootdir}/%{service}/rootwrap/ipset-firewall.filters
%{_datarootdir}/%{service}/rootwrap/iptables-firewall.filters
%{_datarootdir}/%{service}/rootwrap/l3.filters
%{_datarootdir}/%{service}/rootwrap/netns-cleanup.filters
%{_datarootdir}/%{service}/rootwrap/privsep.filters


%files linuxbridge
%license LICENSE
%{_bindir}/neutron-linuxbridge-agent
%{_unitdir}/neutron-linuxbridge-agent.service
%{_datarootdir}/%{service}/rootwrap/linuxbridge-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-agent
%{_sysctldir}/99-neutron-linuxbridge-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules


%files macvtap-agent
%license LICENSE
%{_bindir}/neutron-macvtap-agent
%{_unitdir}/neutron-macvtap-agent.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-macvtap-agent


%files ml2
%license LICENSE
%doc %{service}/plugins/ml2/README
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/*.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini


%files openvswitch
%license LICENSE
%{_bindir}/neutron-openvswitch-agent
%{_unitdir}/neutron-openvswitch-agent.service
%{_unitdir}/neutron-destroy-patch-ports.service
%{_datarootdir}/%{service}/rootwrap/openvswitch-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-openvswitch-agent
%{_sysctldir}/99-neutron-openvswitch-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules


%files metering-agent
%license LICENSE
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metering_agent.ini
%{_unitdir}/neutron-metering-agent.service
%{_bindir}/neutron-metering-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metering-agent


%files rpc-server
%license LICENSE
%{_bindir}/neutron-rpc-server
%{_unitdir}/neutron-rpc-server.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-rpc-server


%files sriov-nic-agent
%license LICENSE
%{_unitdir}/neutron-sriov-nic-agent.service
%{_bindir}/neutron-sriov-nic-agent
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/sriov_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-sriov-nic-agent


%changelog
* Fri Apr 09 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Fri Apr 09 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20210409063435
- [SR-IOV] Do not fail if ip-link vf "min_tx_rate" is not supported (rhbz#1937432)

* Fri Apr 09 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Fri Apr 09 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20210408143453
- Don't configure dnsmasq entries for "network" ports

* Thu Apr 08 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Thu Apr 08 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20210330203536
- Check project_id/tenant_id in API call (rhbz#1877631)

* Tue Mar 30 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Tue Mar 30 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20210329123525
- Schedule networks to new segments if needed (rhbz#1886622)

* Mon Mar 29 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Mon Mar 29 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20210312083508
- [OVS FW] Allow egress ICMPv6 only for know addresses (rhbz#1934330)

* Fri Mar 12 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Fri Mar 12 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20210310111336
- [L3][HA] Retry when setting HA router GW status. (rhbz#1929829)

* Wed Mar 10 2021 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Mon Mar 08 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025051
- Fix wrong packet_type set for IPv6 GRE tunnels in OVS (rhbz#1773732)

* Wed Mar 03 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20201114025050
- Improve "get_devices_with_ip" performance (rhbz#1933661)
- Add minimum bw qos rule validation for network (rhbz#1917648)
- "scope" conversion only just before pyroute2 method call (rhbz#1933662)
- [Fullstack] Wait until min QoS and Queue registers are set in DB (rhbz#1917648)
- Move rejection of min-bw rule on non-physnet port to the ovs qos driver (rhbz#1917648)

* Thu Feb 25 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025049
- [OVS FW] Clean conntrack entries with mark == CT_MARK_INVALID (rhbz#1904463)

* Tue Feb 23 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025048
- Don't try to create default SG when security groups are disabled (rhbz#1920318)

* Thu Feb 18 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025047
- Fix update of trunk subports during live migration (rhbz#1909930)

* Thu Feb 11 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025046
- [GRE] Add possibility to create GRE tunnels over IPv6 (rhbz#1914859)

* Thu Feb 11 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20201114025045
- Process DHCP events in order if related (rhbz#1917538)

* Wed Feb 03 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20201114025044
- Remove undefined variable "host" from ovs agent (rhbz#1860395)
- Fix calling of add_tunnel_port method from sanity checks module (rhbz#1914859)

* Mon Jan 25 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025043
- Enable bulk updates for the dnsmasq (rhbz#1917538)

* Fri Jan 22 2021 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20201114025042
- [OVS] Fix live-migration connection disruption (rhbz#1860395)
- Filter out port with invalid ofport in OVS firewall (rhbz#1860395)

* Fri Jan 22 2021 Slawek Kaplonski <skaplons@redhat.com> 1:15.2.1-1.20201114025041
- Revert "[Security] fix allowed-address-pair 0.0.0.0/0 issue" (rhbz#1918399)
- Do not skip ports with ofport unset or invalid (rhbz#1860395)

* Wed Jan 20 2021 Bernard Cafarelli <bcafarel@redhat.com> 1:15.2.1-1.20201114025040
- neutron-server api worker process should be named to their role (rhbz#1916700)

* Wed Nov 18 2020 Bernard Cafarelli <bcafarel@redhat.com> 1:15.2.1-1.20201114025039
- Remove "vf_management" and "vf_extended_management" checks (rhbz#1894356)

* Fri Nov 13 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Tue Oct 06 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.2.1-1.20200905043435
- Log dissasociation event when a FIP is deleted (rhbz#1542122)

* Sat Sep 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Add 'keepalived_use_no_track' config option

* Fri Sep 04 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix deletion of subnet_id from pd_subnets

* Thu Sep 03 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Don't raise FileNotFoundError during disabling keepalived

* Sat Aug 29 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix port can not be created with the sg of other project

* Fri Aug 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Not remove the running router when MQ is unreachable

* Fri Aug 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix get_ipv6_llas method in the interface driver

* Fri Aug 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Handle properly existing LLA address during l3 agent restart

* Thu Aug 20 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- String to byte conversion should provide the encoding type

* Wed Aug 19 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- [Stable only] Drop *-master jobs

* Wed Aug 19 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- [Security] fix allowed-address-pair 0.0.0.0/0 issue

* Wed Aug 19 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- port_forwarding: validate args before invoking db update

* Fri Aug 07 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Don't check if any bridges were recrected when OVS was restarted
- [OVS][FW] Remote SG IDs left behind when a SG is removed

* Thu Aug 06 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix validation of IPv6 subnets with external RAs

* Wed Aug 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix Traceback when running neutron-ipset-cleanup tool

* Tue Aug 04 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- No rpc_response_max_timeout in LB-agent

* Tue Jul 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- [OVN] Allow IP allocation with different segments for OVN service ports

* Fri Jul 24 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Ensure drop flows on br-int at agent startup for DVR too

* Fri Jul 17 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Optionally use admin powers when deleting DNS records

* Fri Jul 17 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Add config option ``http_retries``

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- [DVR] Related routers should be included if are requested

* Wed Jul 15 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Auto-delete dhcp ports on segment delete

* Wed Jul 15 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Improve log message when port losts its vlan tag

* Tue Jul 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix pep8 job

* Tue Jun 30 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Workaround for TCP checksum issue with ovs-dpdk and  veth pair

* Tue Jun 30 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Do not block connection between br-int and br-phys on startup

* Mon Jun 29 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Sun Jun 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Add "igmp_snooping_enable" config option for OVS agent

* Fri Jun 26 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Make _ensure_default_security_group method atomic

* Fri Jun 26 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fix the wrong value for QoS rate conversion to bytes/s
- [OVS] Make QoS OVS agent deletion operations more resilient

* Thu Jun 25 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- DVR: Remove control plane arp updates for DVR

* Thu Jun 25 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Fixes dnsmasq host file parsing with "addr6_list"

* Wed Jun 24 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Wed Jun 24 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.1.1-0.20200623214706.1a30c1a
- Fixes dnsmasq host file parsing with "addr6_list" (rhbz#1847039)

* Tue Jun 23 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- [DVR] Reconfigure re-created physical bridges for dvr routers

* Tue Jun 23 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Add ensure-tox in functional job
- Use pyroute2 for SRIOV VF commands

* Mon Jun 22 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Configure privsep in SR-IOV agent

* Fri Jun 19 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Migrate neutron grenade multinode jobs to be native Zuul v3

* Thu Jun 11 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Ensure that stale flows are cleaned from phys_bridges

* Thu Jun 11 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches
- Set OpenFlow 1.0, 1.3 and 1.4 by default on bridges

* Fri Jun 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.1.0-1
- Update patches

* Fri May 29 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Add sg name in after delete event kwargs

* Thu May 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Delete segment RPs when network is deleted

* Fri May 22 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Allow usage of legacy 3rd-party interface drivers

* Fri May 22 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches

* Fri May 22 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:15.0.3-0.20200518110604.5c7c832
- Update "ip link" parsing in SR-IOV PCI lib (rhbz#1828834)

* Mon May 18 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Use effective MAC address for macvtap assigned VFs

* Fri May 15 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Add Rocky milestone tag for alembic migration revisions

* Fri May 15 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- SR-IOV: macvtap assigned vf check using sysfs

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Router synch shouldn't return unrelated routers

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Use dhcp-host tag support when supported

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Report L3 extensions enabled in the L3 agent's config

* Wed May 13 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Cap pycodestyle to be < 2.6.0

* Tue May 12 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches

* Tue May 12 2020 Slawek Kaplonski <skaplons@redhat.com> 1:15.0.3-0.20200511113444.c19b9d8
- Use dhcp-host tag support when supported (rhbz#1829201)

* Mon May 11 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Adding LOG statements to debug 1838449

* Wed May 06 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Monkey patch original current_thread _active

* Tue May 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Use dict .get() to avoid a KeyError in the segment plugin

* Sun May 03 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Workaround in NetworkSegmentRange OVO until "project_id" migration

* Tue Apr 28 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Set a default IP route metric in ip_lib.list_ip_routes

* Sat Apr 25 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Replace ctype.CDLL by ctypes.PyDLL in linux.ip_lib

* Fri Apr 24 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Load the glibc library only once for Pyroute2

* Fri Apr 24 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Filter subnet by segment ID or None

* Fri Apr 24 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Avoid raising NetworkInterfaceNotFound exception in DHCP agent logs

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- [L3 HA] Add "no_track" option to VIPs in keepalived config

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Increase log information when a RootHelperProcess fails
- Default (shared) network segment range is not mandatory
- Improve port retrieval when validating auto address

* Wed Apr 22 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Add rootwrap filter rule for radvd-kill script

* Fri Apr 17 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- "keepalived_state_change" needs to use threading to send arping

* Fri Apr 17 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Replace "ip monitor" command with Pyroute2 implementation

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Filter by owner SGs when retrieving the SG rules

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Check tc_lib.add_tc_policy_class input parameters

* Wed Apr 15 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Prioritize port create and update ready messages

* Tue Apr 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Increase waiting time for network rescheduling
- Use threads insted of greethreads in IP monitor

* Tue Apr 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Wait before deleting trunk bridges for DPDK vhu

* Mon Apr 13 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Ensure netlink.nla_slot tuple key is a string
- Fix return correct cache when reusing port
- Do not link up HA router gateway in backup node
- Neutron ovs agent: Removing SmartNIC OVS representor port on instance tear down and resync

* Wed Apr 08 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Revert "Switch to use cast method in dhcp_ready_on_ports method"

* Mon Apr 06 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Add trunk subports to be one of dvr serviced device owners

* Mon Apr 06 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- [OvS] Handle re_added multi ports
- [DVR] Don't populate unbound ports in router's ARP cache

* Fri Mar 27 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- DHCPv6 - Use addr6_list in dnsmasq

* Fri Mar 27 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- ovsdb monitor: handle modified ports

* Fri Mar 27 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Reno only - Make stateless allocation segment aware
- Deny delete last slaac subnet with allocation on segment
- subnet create - segment aware auto-addr allocation
- Filter subnets on fixed_ips segment

* Thu Mar 26 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Use rally-openstack 1.7.0 for stable/train
- Register DNSMASQ_OPTS in functional sanity tests
- Fix queries to retrieve allocations with network_segment_range

* Sat Mar 21 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Improve VLAN allocations synchronization

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Add "project_id" filter when changing the network segmentation ID
- Remove extra header fields in proxied metadata requests
- Ensure that default SG exists during list of SG rules API call
- Do not initialize snat-ns twice
- Re-use existing ProcessLauncher from wsgi in RPC workers

* Tue Feb 25 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- Check SG members instead of ports to skip flow update
- ovs agent: signal to plugin if tunnel refresh needed

* Wed Feb 19 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches
- dhcp-agent: equalize port create_low/update/delete priority

* Tue Feb 18 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.2-1
- Update patches

* Fri Feb 14 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- [OVS] Handle added/removed ports in the same polling iteration

* Wed Feb 12 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Unnecessary routers should not be created

* Thu Feb 06 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Check "security_group_rule" quota during security group creation

* Wed Feb 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Reset timeout exception in DietTestCase when retrying
- Force arp_responder to True when DVR and tunneling enabled

* Wed Feb 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Remove sleep command when retrieving OVS dp

* Wed Feb 05 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "Randomize BaseFullStackTestCase._find_available_ips" into stable/train
- Randomize BaseFullStackTestCase._find_available_ips

* Tue Feb 04 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "Add accepted egress direct flow" into stable/train
- Add accepted egress direct flow

* Fri Jan 31 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "Allow to kill keepalived state change monitor process" into stable/train
- Merge "Ensure driver error preventing trunk port deletion is logged" into stable/train
- Ensure driver error preventing trunk port deletion is logged
- Allow to kill keepalived state change monitor process

* Thu Jan 30 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Remove one of iptables_hybrid jobs

* Sat Jan 25 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "[L3] Switch order of processing added and removed router ports" into stable/train
- [L3] Switch order of processing added and removed router ports

* Mon Jan 20 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- [L3] Switch order of processing added and removed router ports (rhbz#1790417)
- Merge "Fix bug number in release note" into stable/train
- Merge "Locate RP-tree parent by hypervisor name" into stable/train
- Fix bug number in release note
- Locate RP-tree parent by hypervisor name

* Thu Jan 16 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- [L3] Switch order of processing added and removed router ports (rhbz#1790417)
- Add retries to update trunk port

* Thu Jan 09 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "Use "via" in gateway dictionary in Linux Bridge agent" into stable/train
- Use "via" in gateway dictionary in Linux Bridge agent

* Tue Jan 07 2020 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Check mtu on network update

* Fri Dec 20 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches
- Merge "don't clear skb mark when ovs is hw-offload enabled" into stable/train
- don't clear skb mark when ovs is hw-offload enabled

* Fri Dec 20 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.1-1
- Update patches

* Thu Dec 19 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Use constraints for docs tox target" into stable/train
- Merge "List SG rules which belongs to tenant's SG" into stable/train
- Cap hacking in test-requirements.txt
- Use constraints for docs tox target
- List SG rules which belongs to tenant's SG

* Wed Dec 04 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "[OVS FW] Clean port rules if port not found in ovsdb" into stable/train
- [OVS FW] Clean port rules if port not found in ovsdb

* Wed Dec 04 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Skip test_linuxbridge_arp_protect functional tests (rhbz#1779221)
- Merge "Convert Pyroute2 byte results to strings" into stable/train
- Convert Pyroute2 byte results to strings

* Tue Dec 03 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Add more condition to check sg member exist

* Thu Nov 28 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Switch to stable/train neutron-tempest-plugin jobs in train branch" into stable/train
- Switch to stable/train neutron-tempest-plugin jobs in train branch

* Wed Nov 27 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Set DB retry for quota_enforcement pecan_wsgi hook" into stable/train
- Set DB retry for quota_enforcement pecan_wsgi hook

* Mon Nov 25 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "NetcatTester.stop_processes skip "No such process" exception" into stable/train
- NetcatTester.stop_processes skip "No such process" exception

* Fri Nov 22 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Imported Translations from Zanata

* Thu Nov 21 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Switch to use cast method in dhcp_ready_on_ports method" into stable/train
- Switch to use cast method in dhcp_ready_on_ports method

* Wed Nov 20 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Remove Floating IP DNS record upon associated port deletion" into stable/train
- TestMinBwQoSOvs must call the correct methods
- Remove Floating IP DNS record upon associated port deletion

* Tue Nov 12 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Increase timeout when waiting for dnsmasq enablement" into stable/train
- Merge "Set rootwrap daemon timeout for fullstack and functional tests" into stable/train
- Set rootwrap daemon timeout for fullstack and functional tests
- Increase timeout when waiting for dnsmasq enablement

* Thu Nov 07 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Log OVS firewall conjunction creation

* Thu Oct 31 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Check dnsmasq process is active when spawned

* Tue Oct 29 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Handle OVSFWPortNotFound and OVSFWTagNotFound in ovs firewall

* Sat Oct 26 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Add radvd_user config option

* Fri Oct 25 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches

* Thu Oct 24 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Fix mismatch of tags in dnsmasq options" into stable/train
- Fix mismatch of tags in dnsmasq options

* Wed Oct 23 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Use admin context when updating router gateway" into stable/train
- Use admin context when updating router gateway

* Tue Oct 22 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- [nova][train] Docs: Remove deprecated RetryFilter

* Sat Oct 19 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Handle ports assigned to routers without routerports" into stable/train
- Handle ports assigned to routers without routerports

* Fri Oct 18 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- Merge "Add policy config for get_flavor_service_profile operation" into stable/train
- Add policy config for get_flavor_service_profile operation

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches
- switch to the newly created opensuse-15 nodeset

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-1
- Update patches

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-0.2.0rc2
- Update patches
- Randomize VNI in FdbInterfaceTestCase

* Thu Oct 10 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-0.1.0rc1
- Update patches
- Merge "fixed_configured=True when Add/Remove port IPs" into stable/train
- fixed_configured=True when Add/Remove port IPs

* Wed Oct 09 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-0.1.0rc1
- Update patches
- Configure keepalived interfaces according to config file

* Thu Oct 03 2019 OSP Prod Chain <dev-null@redhat.com> 1:15.0.0-0.1.0rc1
- Update patches
- Imported Translations from Zanata

* Mon Sep 30 2019 RDO <dev@lists.rdoproject.org> 1:15.0.0-0.1.0rc1
- Update to 15.0.0.0rc1

